Unit DE31R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE10_p;

procedure DE31R(FA :Proc_F3_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; N :Integer;
                NS :Integer; var Y :Array of Real;
                var A :Array of Real; var E :Array of Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var IERR :Integer);

implementation

procedure DE31R(FA :Proc_F3_DE; M :Integer; XN :Real;
                var YN :Array of Real; XK :Real; N :Integer;
                NS :Integer; var Y :Array of Real;
                var A :Array of Real; var E :Array of Real;
                var R :Array of Real; var R1 :Array of Real;
                var R2 :Array of Real; var R3 :Array of Real;
                var IERR :Integer);
var
I,J,L,I1,N0,IS_,B :Integer;
DL,DL1,H,RA,X :Real;
const
//C1D7 :Real = 0.1428571428571429;
//C7M1 :Integer = 6;
C1D7 :Extended = 0.71428571428571428571e-1;
C7M1 :Integer = 13;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44;
begin
IERR := 0;
for I:=1 to M do
 begin
  Y[I-1] := YN[I-1];
_1:
 end;
if ( XN = XK ) 
 then goto _44;
if ( N < 1 ) 
 then goto _41;
if ( NS < 1 ) 
 then goto _42;
DL := (XK-XN)/(NS);
DL1 := 0.5*DL;
X := XN;
for IS_:=1 to NS do
 begin
  FA(A,X+DL1,M);
  H := DL/(N);
  for I:=1 to M do
   begin
    for J:=1 to M do
     begin
      A[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M]*H;
_2:
     end;
_3:
   end;
  for I:=1 to M do
   begin
    for J:=1 to M do
     begin
      E[(I-1)+(J-1)*M] := A[(I-1)+(J-1)*M];
_4:
     end;
_5:
   end;
  RA := C1D7;
  I1 := C7M1;
_6:
  for I:=1 to M do
   begin
    for J:=1 to M do
     begin
      E[(I-1)+(J-1)*M] := E[(I-1)+(J-1)*M]*RA;
_7:
     end;
    E[(I-1)+(I-1)*M] := E[(I-1)+(I-1)*M]+1.0;
_8:
   end;
  for L:=1 to M do
   begin
    for I:=1 to M do
     begin
      RA := 0.0;
      for J:=1 to M do
       begin
        RA := RA+A[(I-1)+(J-1)*M]*E[(J-1)+(L-1)*M];
_9:
       end;
      R[I-1] := RA;
_10:
     end;
    for I:=1 to M do
     begin
      E[(I-1)+(L-1)*M] := R[I-1];
_11:
     end;
_12:
   end;
  RA := 1.0/(I1);
  I1 := I1-1;
  if ( I1 <> 0 ) 
   then goto _6;
  for I:=1 to M do
   begin
    E[(I-1)+(I-1)*M] := E[(I-1)+(I-1)*M]+1.0;
_13:
   end;
  B := N;
  N0 := N;
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
      R1[(I-1)+(J-1)*M] := 0.0;
_14:
     end;
    R1[(J-1)+(J-1)*M] := 1.0;
_15:
   end;
  I1 := 1;
  goto _25;
_16:
  case I1 of
   1: goto _17;
   2: goto _21;
  end;
_17:
  for L:=1 to M do
   begin
    for I:=1 to M do
     begin
      RA := 0.0;
      for J:=1 to M do
       begin
        RA := RA+E[(I-1)+(J-1)*M]*E[(J-1)+(L-1)*M];
_18:
       end;
      R2[(I-1)+(L-1)*M] := RA;
_19:
     end;
_20:
   end;
  I1 := 2;
  goto _25;
_21:
  for L:=1 to M do
   begin
    for I:=1 to M do
     begin
      RA := 0.0;
      for J:=1 to M do
       begin
        RA := RA+R2[(I-1)+(J-1)*M]*R2[(J-1)+(L-1)*M];
_22:
       end;
      E[(I-1)+(L-1)*M] := RA;
_23:
     end;
_24:
   end;
  I1 := 1;
_25:
  N0 := B div 2;
  if ( B-2*N0 = 0 ) 
   then goto _36;
  case I1 of
   1: goto _26;
   2: goto _31;
  end;
_26:
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
      RA := 0.0;
      for L:=1 to M do
       begin
        RA := RA+E[(I-1)+(L-1)*M]*R1[(L-1)+(J-1)*M];
_27:
       end;
      R[I-1] := RA;
_28:
     end;
    for I:=1 to M do
     begin
      R1[(I-1)+(J-1)*M] := R[I-1];
_29:
     end;
_30:
   end;
  goto _36;
_31:
  for J:=1 to M do
   begin
    for I:=1 to M do
     begin
      RA := 0.0;
      for L:=1 to M do
       begin
        RA := RA+R2[(I-1)+(L-1)*M]*R1[(L-1)+(J-1)*M];
_32:
       end;
      R[I-1] := RA;
_33:
     end;
    for I:=1 to M do
     begin
      R1[(I-1)+(J-1)*M] := R[I-1];
_34:
     end;
_35:
   end;
_36:
  B := N0;
  if ( B <> 0 ) 
   then goto _16;
  for I:=1 to M do
   begin
    RA := 0.0;
    for J:=1 to M do
     begin
      RA := RA+R1[(I-1)+(J-1)*M]*Y[J-1];
_37:
     end;
    R3[I-1] := RA;
_38:
   end;
  X := X+DL;
  for I:=1 to M do
   begin
    Y[I-1] := R3[I-1];
_39:
   end;
_40:
 end;
goto _44;
_41:
IERR := 65;
goto _43;
_42:
IERR := 66;
_43:
UTDE10(IERR,31);
_44:
end;

end.
